//+------------------------------------------------------------------+
//|                 Fibo_Stochastic_jytv4_test_Pesavento_numbers.mq4 |
//|                                 Third: Larry Pesavento's numbers`|
//|                                              STOCHASTIC FIBONACCI|
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red

#define arrowsDisplacement 0.0001

double stoch1 = 0.0;
double stoch2 = 0.0;
double stoch3 = 0.0;
double stoch4 = 0.0;
double stoch5 = 0.0;
double stoch6 = 0.0;
double stoch7 = 0.0;
double stoch8 = 0.0;
double stoch9 = 0.0;
double stoch10 = 0.0;
double stoch11 = 0.0;
double stoch12 = 0.0;

double SumStoch2 = 0.0;
double CalculFiboStoch2 = 0.0;
extern double percent2 = 14.0;

int shift = 0;
int bars = 0;
int i = 0;
bool flag = TRUE;
//---- buffers
double bullishDivergence[];
double bearishDivergence[];

double ExtMapBuffer5[];
double ExtMapBuffer6[];

double signal[];

int init() {
   IndicatorBuffers(4);

   SetIndexBuffer(0, ExtMapBuffer5);
   SetIndexBuffer(1, ExtMapBuffer6);
   SetIndexBuffer(2, bullishDivergence);
   SetIndexBuffer(3, bearishDivergence);
   
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,0,Blue);
   SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,0,Red);
   
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexStyle(3, DRAW_ARROW);

   
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   IndicatorShortName("Fibo_Stochastic_jytv4_test_Pesavento_numbers");

   SetIndexDrawBegin(0, ExtMapBuffer5);
   SetIndexDrawBegin(1, ExtMapBuffer6);
   SetIndexArrow(2, 233);
   SetIndexArrow(3, 234);
      
   return (0);
}

int start() {

   if (Bars < bars) flag = TRUE;
   if (Bars - bars > 1) flag = TRUE;
   bars = Bars;
   if (flag) {
      i = Bars - 1;
      if (i < 0) return (0);
      flag = FALSE;
   }
   i++;
   for (shift = i; shift >= 0; shift--) {

   // Third: Larry Pesavento's numbers
   // 0.25 - 0.382 - 0.5 - 0.618 - 0.707 - 0.786 - 0.841 - 1.0 - 1.128 - 1.272 - 1.414 - 1.618 - 2.0 - 2.618


      stoch1  = 0.25 * iStochastic(NULL, 0,  5 , 3, 2, MODE_SMA, 0, MODE_MAIN, shift);
      stoch2 = 0.382 * iStochastic(NULL, 0,  8, 9, 5, MODE_SMA, 0, MODE_MAIN, shift);
      stoch3 = 0.5   * iStochastic(NULL, 0, 13, 19, 9, MODE_SMA, 0, MODE_MAIN, shift);
      stoch4  = 0.618 * iStochastic(NULL, 0, 21, 33, 14, MODE_SMA, 0, MODE_MAIN, shift);
      stoch5 = 0.707 * iStochastic(NULL, 0, 34, 51, 20, MODE_SMA, 0, MODE_MAIN, shift);
      stoch6 = 0.786 * iStochastic(NULL, 0, 55, 73, 27, MODE_SMA, 0, MODE_MAIN, shift);       
      stoch7 = 0.841 * iStochastic(NULL, 0, 89, 99, 35, MODE_SMA, 0, MODE_MAIN, shift);      
      stoch8 = 1     * iStochastic(NULL, 0, 144, 127, 44, MODE_SMA, 0, MODE_MAIN, shift);     
      stoch9 = 1.128  * iStochastic(NULL, 0, 233, 159, 54, MODE_SMA, 0, MODE_MAIN, shift);     
      stoch10 = 1.272 * iStochastic(NULL, 0, 377, 193, 65, MODE_SMA, 0, MODE_MAIN, shift);       
      stoch10 = 1.414 * iStochastic(NULL, 0, 610, 229, 77, MODE_SMA, 0, MODE_MAIN, shift);  
      stoch10 = 1.618 * iStochastic(NULL, 0, 987, 269, 90, MODE_SMA, 0, MODE_MAIN, shift);        
            
      SumStoch2 = stoch1 + stoch2 + stoch3 + stoch4 + stoch5 + stoch6 + stoch7 + stoch8 + stoch9 + stoch10 + stoch11 + stoch12;
      CalculFiboStoch2 = SumStoch2 / percent2 + (ExtMapBuffer6[shift + 1]) * (percent2 - 1.0) / percent2;
      ExtMapBuffer5[shift] = SumStoch2;
      ExtMapBuffer6[shift] = CalculFiboStoch2;
      
      CatchBullishDivergence(shift+2);
      CatchBearishDivergence(shift+2);      
      
      i--;
   }
   return (0);
}

//+------------------------------------------------------------------+
//|  BULLISH  HAUSSIER                                                                 |
//+------------------------------------------------------------------+
void CatchBullishDivergence(int shift2){
   if(!(ExtMapBuffer5[shift2] >= ExtMapBuffer5[shift2+1] && ExtMapBuffer6[shift2] < ExtMapBuffer6[shift2+2] && ExtMapBuffer5[shift2] < ExtMapBuffer5[shift2-1]))return;  
   int lastTrough=GetIndicatorLastTrough(shift2);
//----   
   if(ExtMapBuffer5[shift2]>=ExtMapBuffer5[lastTrough] && ExtMapBuffer5[shift2]>=ExtMapBuffer6[lastTrough]){
      bullishDivergence[shift2] = ExtMapBuffer5[shift2]-arrowsDisplacement;                        
   }
//----   
   if(ExtMapBuffer6[shift2]<=ExtMapBuffer6[lastTrough]&&ExtMapBuffer5[shift2]>=ExtMapBuffer6[lastTrough]){
      bullishDivergence[shift2] = ExtMapBuffer5[shift2]-arrowsDisplacement;
    }      
  }
//+------------------------------------------------------------------+
//|  BEARICH BAISSIER                                                                 |
//+------------------------------------------------------------------+
void CatchBearishDivergence(int shift2){
     if(!(ExtMapBuffer6[shift2] <= ExtMapBuffer5[shift2+1] && ExtMapBuffer5[shift2] > ExtMapBuffer5[shift2+2] && ExtMapBuffer6[shift2] > ExtMapBuffer6[shift2-1]))return;
     int lastPeak = GetIndicatorLastPeak(shift2);  
     
     if(ExtMapBuffer5[shift2] <= ExtMapBuffer5[lastPeak] && ExtMapBuffer5[shift2] <= ExtMapBuffer6[lastPeak]){
       bearishDivergence[shift2] = ExtMapBuffer6[shift2] + arrowsDisplacement;       
     }
     if(ExtMapBuffer6[shift2] >= ExtMapBuffer6[lastPeak] && ExtMapBuffer5[shift2] <= ExtMapBuffer6[lastPeak]){
       bearishDivergence[shift2] = ExtMapBuffer6[shift2] + arrowsDisplacement;
     }   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastPeak(int shift2){
    for(int i = shift2 + 5; i < Bars; i++){
       if(signal[i] >= signal[i+1] && signal[i] >= signal[i+2] && signal[i] >= signal[i-1] && signal[i] >= signal[i-2]){
          for(int j = i; j < Bars; j++){
             if(ExtMapBuffer6[j] >= ExtMapBuffer6[j+1] && ExtMapBuffer6[j] > ExtMapBuffer6[j+2] 
             && ExtMapBuffer5[j] >= ExtMapBuffer5[j-1] && ExtMapBuffer5[j] > ExtMapBuffer5[j-2])
             return(j);
          }
       }
    }
    return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastTrough(int shift2){
    for(int i = shift2 + 5; i < Bars; i++){
        if(signal[i] <= signal[i+1] && signal[i] <= signal[i+2] && signal[i] <= signal[i-1] && signal[i] <= signal[i-2]){
           for(int j = i; j < Bars; j++){
                if(ExtMapBuffer6[j] <= ExtMapBuffer6[j+1] && ExtMapBuffer6[j] < ExtMapBuffer6[j+2]
                && ExtMapBuffer5[j] <= ExtMapBuffer5[j-1] && ExtMapBuffer5[j] < ExtMapBuffer5[j-2])
                   return(j);
           }
        }
    }
    return(-1);
}


